/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include <unity.h>
#include <poker/card.h>

void setUp(void) {
}

void tearDown(void) {
}

void test_cardWriteDeck_should_WriteCardsToArray() {
  card_t cards[CARD_DECK_SIZE];
  cardWriteDeck(cards);
  
  TEST_ASSERT_EQUAL_UINT8(CARD_CLUBS_TWO, cards[0]);
  TEST_ASSERT_EQUAL_UINT8(CARD_CLUBS_THREE, cards[1]);
  TEST_ASSERT_EQUAL_UINT8(CARD_CLUBS_FOUR, cards[2]);
  TEST_ASSERT_EQUAL_UINT8(CARD_CLUBS_ACE, cards[12]);

  TEST_ASSERT_EQUAL_UINT8(CARD_DIAMONDS_NINE, cards[20]);

  TEST_ASSERT_EQUAL_UINT8(CARD_HEARTS_ACE, cards[38]);

  TEST_ASSERT_EQUAL_UINT8(CARD_SPADES_ACE, cards[51]);
}

void test_cardWriteDeck_should_ReturnCardsWritten() {
  card_t cards[CARD_DECK_SIZE];
  TEST_ASSERT_EQUAL_UINT8(CARD_DECK_SIZE, cardWriteDeck(cards));
}

int main() {
  UNITY_BEGIN();
  
  RUN_TEST(test_cardWriteDeck_should_WriteCardsToArray);
  RUN_TEST(test_cardWriteDeck_should_ReturnCardsWritten);

  return UNITY_END();
}